809780646f047893a0629daca037cf7c0d17e002
[openwrt/openwrt.git] / package / madwifi / files / lib / wifi / madwifi.sh
1 #!/bin/sh
2 append DRIVERS "atheros"
3
4 scan_atheros() {
5 local device="$1"
6 local wds
7 local adhoc ahdemo sta ap monitor
8
9 config_get vifs "$device" vifs
10 for vif in $vifs; do
11
12 config_get ifname "$vif" ifname
13 config_set "$vif" ifname "${ifname:-ath}"
14
15 config_get mode "$vif" mode
16 case "$mode" in
17 adhoc|ahdemo|sta|ap|monitor)
18 append $mode "$vif"
19 ;;
20 wds)
21 config_get ssid "$vif" ssid
22 [ -z "$ssid" ] && continue
23
24 config_set "$vif" wds 1
25 config_set "$vif" mode sta
26 mode="sta"
27 addr="$ssid"
28 ${addr:+append $mode "$vif"}
29 ;;
30 *) echo "$device($vif): Invalid mode, ignored."; continue;;
31 esac
32 done
33
34 case "${adhoc:+1}:${sta:+1}:${ap:+1}" in
35 # valid mode combinations
36 1::) wds="";;
37 1::1);;
38 :1:1)config_set "$device" nosbeacon 1;; # AP+STA, can't use beacon timers for STA
39 :1:);;
40 ::1);;
41 ::);;
42 *) echo "$device: Invalid mode combination in config"; return 1;;
43 esac
44
45 config_set "$device" vifs "${sta:+$sta }${ap:+$ap }${adhoc:+$adhoc }${ahdemo:+$ahdemo }${wds:+$wds }${monitor:+$monitor}"
46 }
47
48
49 disable_atheros() (
50 local device="$1"
51
52 set_wifi_down "$device"
53
54 include /lib/network
55 cd /proc/sys/net
56 for dev in *; do
57 grep "$device" "$dev/%parent" >/dev/null 2>/dev/null && {
58 [ -f "/var/run/wifi-${dev}.pid" ] &&
59 kill "$(cat "/var/run/wifi-${dev}.pid")"
60 ifconfig "$dev" down
61 unbridge "$dev"
62 wlanconfig "$dev" destroy
63 }
64 done
65 return 0
66 )
67
68 enable_atheros() {
69 local device="$1"
70
71 config_get regdomain "$device" regdomain
72 [ -n "$regdomain" ] && echo "$regdomain" > /proc/sys/dev/$device/regdomain
73
74 config_get country "$device" country
75 [ -z "$country" ] && country="0"
76 echo "$country" > /proc/sys/dev/$device/countrycode
77
78 config_get_bool outdoor "$device" outdoor "0"
79 echo "$outdoor" > /proc/sys/dev/$device/outdoor
80
81 config_get channel "$device" channel
82 config_get vifs "$device" vifs
83 config_get txpower "$device" txpower
84
85 [ auto = "$channel" ] && channel=0
86
87 config_get_bool antdiv "$device" diversity
88 config_get antrx "$device" rxantenna
89 config_get anttx "$device" txantenna
90 config_get_bool softled "$device" softled 1
91
92 devname="$(cat /proc/sys/dev/$device/dev_name)"
93 antgpio=
94 case "$devname" in
95 NanoStation2) antgpio=7;;
96 NanoStation5) antgpio=1;;
97 esac
98 if [ -n "$antgpio" ]; then
99 softled=0
100 config_get antenna "$device" antenna
101 case "$antenna" in
102 external) antdiv=0; antrx=1; anttx=1 ;;
103 horizontal) antdiv=0; antrx=1; anttx=1 ;;
104 vertical) antdiv=0; antrx=2; anttx=2 ;;
105 auto) antdiv=1; antrx=0; anttx=0 ;;
106 esac
107
108 [ -x "$(which gpioctl 2>/dev/null)" ] || antenna=
109 case "$antenna" in
110 horizontal|vertical|auto)
111 gpioctl "dirout" "$antgpio" >/dev/null 2>&1
112 gpioctl "set" "$antgpio" >/dev/null 2>&1
113 ;;
114 external)
115 gpioctl "dirout" "$antgpio" >/dev/null 2>&1
116 gpioctl "clear" "$antgpio" >/dev/null 2>&1
117 ;;
118 esac
119 fi
120
121 [ -n "$antdiv" ] && sysctl -w dev."$device".diversity="$antdiv" >&-
122 [ -n "$antrx" ] && sysctl -w dev."$device".rxantenna="$antrx" >&-
123 [ -n "$anttx" ] && sysctl -w dev."$device".txantenna="$anttx" >&-
124 [ -n "$softled" ] && sysctl -w dev."$device".softled="$softled" >&-
125
126 config_get distance "$device" distance
127 [ -n "$distance" ] && sysctl -w dev."$device".distance="$distance" >&-
128
129 local first=1
130 for vif in $vifs; do
131 local start_hostapd= vif_txpower= nosbeacon=
132 config_get ifname "$vif" ifname
133 config_get enc "$vif" encryption
134 config_get eap_type "$vif" eap_type
135 config_get mode "$vif" mode
136
137 case "$mode" in
138 sta) config_get nosbeacon "$device" nosbeacon;;
139 adhoc) config_get nosbeacon "$vif" sw_merge;;
140 esac
141
142 ifname=$(wlanconfig "$ifname" create wlandev "$device" wlanmode "$mode" ${nosbeacon:+nosbeacon})
143 [ $? -ne 0 ] && {
144 echo "enable_atheros($device): Failed to set up $mode vif $ifname" >&2
145 continue
146 }
147 config_set "$vif" ifname "$ifname"
148
149 # only need to change freq band and channel on the first vif
150 [ "$first" = 1 ] && {
151 config_get hwmode "$device" hwmode
152 [ -z "$hwmode" ] && config_get hwmode "$device" mode
153
154 pureg=0
155 case "$hwmode" in
156 *b) hwmode=11b;;
157 *bg) hwmode=11g;;
158 *g) hwmode=11g; pureg=1;;
159 *gdt) hwmode=11gdt;;
160 *a) hwmode=11a;;
161 *adt) hwmode=11adt;;
162 *ast) hwmode=11ast;;
163 *fh) hwmode=fh;;
164 *) hwmode=auto;;
165 esac
166 iwpriv "$ifname" mode "$hwmode"
167 iwpriv "$ifname" pureg "$pureg"
168
169 iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null
170 }
171
172 config_get_bool hidden "$vif" hidden 0
173 iwpriv "$ifname" hide_ssid "$hidden"
174
175 config_get ff "$vif" ff
176 if [ -n "$ff" ]; then
177 iwpriv "$ifname" ff "$ff"
178 fi
179
180 config_get wds "$vif" wds
181 case "$wds" in
182 1|on|enabled) wds=1;;
183 *) wds=0;;
184 esac
185 iwpriv "$ifname" wds "$wds"
186
187 [ "$mode" = ap -a "$wds" = 1 ] && {
188 config_get_bool wdssep "$vif" wdssep 1
189 [ -n "$wdssep" ] && iwpriv "$ifname" wdssep "$wdssep"
190 }
191
192 case "$enc" in
193 WEP|wep)
194 for idx in 1 2 3 4; do
195 config_get key "$vif" "key${idx}"
196 iwconfig "$ifname" enc "[$idx]" "${key:-off}"
197 done
198 config_get key "$vif" key
199 key="${key:-1}"
200 case "$key" in
201 [1234]) iwconfig "$ifname" enc "[$key]";;
202 *) iwconfig "$ifname" enc "$key";;
203 esac
204 ;;
205 psk*|wpa*)
206 start_hostapd=1
207 config_get key "$vif" key
208 ;;
209 esac
210
211 case "$mode" in
212 sta|adhoc|ahdemo)
213 config_get addr "$vif" bssid
214 [ -z "$addr" ] || {
215 iwconfig "$ifname" ap "$addr"
216 }
217 ;;
218 esac
219
220 config_get_bool bgscan "$vif" bgscan
221 [ -n "$bgscan" ] && iwpriv "$ifname" bgscan "$bgscan"
222
223 config_get rate "$vif" rate
224 [ -n "$rate" ] && iwconfig "$ifname" rate "${rate%%.*}"
225
226 config_get mcast_rate "$vif" mcast_rate
227 [ -n "$mcast_rate" ] && iwpriv "$ifname" mcast_rate "${mcast_rate%%.*}"
228
229 config_get frag "$vif" frag
230 [ -n "$frag" ] && iwconfig "$ifname" frag "${frag%%.*}"
231
232 config_get rts "$vif" rts
233 [ -n "$rts" ] && iwconfig "$ifname" rts "${rts%%.*}"
234
235 config_get_bool comp "$vif" compression 0
236 iwpriv "$ifname" compression "$comp"
237
238 config_get_bool minrate "$vif" minrate
239 [ -n "$minrate" ] && iwpriv "$ifname" minrate "$minrate"
240
241 config_get_bool maxrate "$vif" maxrate
242 [ -n "$maxrate" ] && iwpriv "$ifname" maxrate "$maxrate"
243
244 config_get_bool burst "$vif" bursting
245 [ -n "$burst" ] && iwpriv "$ifname" burst "$burst"
246
247 config_get_bool wmm "$vif" wmm
248 [ -n "$wmm" ] && iwpriv "$ifname" wmm "$wmm"
249
250 config_get_bool xr "$vif" xr
251 [ -n "$xr" ] && iwpriv "$ifname" xr "$xr"
252
253 config_get_bool ar "$vif" ar
254 [ -n "$ar" ] && iwpriv "$ifname" ar "$ar"
255
256 config_get_bool beacon_power "$vif" beacon_power
257 [ -n "$beacon_power" ] && iwpriv "$ifname" beacon_pwr "$beacon_power"
258
259 config_get_bool doth "$vif" doth 0
260 [ -n "$doth" ] && iwpriv "$ifname" doth "$doth"
261
262 config_get_bool probereq "$vif" probereq
263 [ -n "$probereq" ] && iwpriv "$ifname" probereq "$probereq"
264
265 config_get maclist "$vif" maclist
266 [ -n "$maclist" ] && {
267 # flush MAC list
268 iwpriv "$ifname" maccmd 3
269 for mac in $maclist; do
270 iwpriv "$ifname" addmac "$mac"
271 done
272 }
273
274 config_get macpolicy "$vif" macpolicy
275 case "$macpolicy" in
276 allow)
277 iwpriv "$ifname" maccmd 1
278 ;;
279 deny)
280 iwpriv "$ifname" maccmd 2
281 ;;
282 *)
283 # default deny policy if mac list exists
284 [ -n "$maclist" ] && iwpriv "$ifname" maccmd 2
285 ;;
286 esac
287
288 ifconfig "$ifname" up
289
290 local net_cfg bridge
291 net_cfg="$(find_net_config "$vif")"
292 [ -z "$net_cfg" ] || {
293 bridge="$(bridge_interface "$net_cfg")"
294 config_set "$vif" bridge "$bridge"
295 start_net "$ifname" "$net_cfg"
296 }
297
298 config_get ssid "$vif" ssid
299 [ -n "$ssid" ] && {
300 iwconfig "$ifname" essid on
301 iwconfig "$ifname" essid "$ssid"
302 }
303
304 set_wifi_up "$vif" "$ifname"
305
306 # TXPower settings only work if device is up already
307 # while atheros hardware theoretically is capable of per-vif (even per-packet) txpower
308 # adjustment it does not work with the current atheros hal/madwifi driver
309
310 config_get vif_txpower "$vif" txpower
311 # use vif_txpower (from wifi-iface) instead of txpower (from wifi-device) if
312 # the latter doesn't exist
313 txpower="${txpower:-$vif_txpower}"
314 [ -z "$txpower" ] || iwconfig "$ifname" txpower "${txpower%%.*}"
315
316 case "$mode" in
317 ap)
318 config_get_bool isolate "$vif" isolate 0
319 iwpriv "$ifname" ap_bridge "$((isolate^1))"
320
321 if [ -n "$start_hostapd" ] && eval "type hostapd_setup_vif" 2>/dev/null >/dev/null; then
322 hostapd_setup_vif "$vif" madwifi || {
323 echo "enable_atheros($device): Failed to set up hostapd for interface $ifname" >&2
324 # make sure this wifi interface won't accidentally stay open without encryption
325 ifconfig "$ifname" down
326 wlanconfig "$ifname" destroy
327 continue
328 }
329 fi
330 ;;
331 wds|sta)
332 if eval "type wpa_supplicant_setup_vif" 2>/dev/null >/dev/null; then
333 wpa_supplicant_setup_vif "$vif" madwifi || {
334 echo "enable_atheros($device): Failed to set up wpa_supplicant for interface $ifname" >&2
335 ifconfig "$ifname" down
336 wlanconfig "$ifname" destroy
337 continue
338 }
339 fi
340 ;;
341 esac
342 first=0
343 done
344 }
345
346
347 detect_atheros() {
348 cd /proc/sys/dev
349 [ -d ath ] || return
350 for dev in $(ls -d wifi* 2>&-); do
351 config_get type "$dev" type
352 devname="$(cat /proc/sys/dev/$dev/dev_name)"
353 case "$devname" in
354 NanoStation*)
355 EXTRA_DEV="
356 # Ubiquiti NanoStation features
357 option antenna auto # (auto|horizontal|vertical|external)
358 "
359 ;;
360 esac
361 [ "$type" = atheros ] && continue
362 cat <<EOF
363 config wifi-device $dev
364 option type atheros
365 option channel auto
366 $EXTRA_DEV
367 # REMOVE THIS LINE TO ENABLE WIFI:
368 option disabled 1
369
370 config wifi-iface
371 option device $dev
372 option network lan
373 option mode ap
374 option ssid OpenWrt
375 option encryption none
376 EOF
377 done
378 }